package heapabstraction;
import com.ibm.wala.dataflow.graph.AbstractMeetOperator;
import com.ibm.wala.fixpoint.IVariable;
import java.util.Iterator;
import com.ibm.wala.fixpoint.FixedPointConstants;

class MeetOperator extends AbstractMeetOperator<AbstractState>{
	    	private static int uniqid = 0;
	    	int myid = uniqid++;
	    	
	    	// What other private variables should we keep around?
	    	
			@Override
			public boolean equals(Object o) {
				if ((this.getClass()).equals(o.getClass())) {
					MeetOperator mo = (MeetOperator)o;
					// TODO: Need to do some things here.
					return true;
				} else {
					return false;
				}
			}
			
			@Override
			public byte evaluate(AbstractState lhs, IVariable[] rhs) {
				//This function updates the LHS AbstractState with the 
				//join of all the elements in the RHS abstract state. 
				//The rhs array will also contain AbstractStates.
				boolean changed = false;
				
				System.out.println("== MEET OPERATOR ==");
				for (int i = 0; i < rhs.length; ++i) {
					IVariable cur = rhs[i];
					if (cur instanceof AbstractState) {
						AbstractState curAS = (AbstractState)cur;
						curAS.initializeHeapFields(-1);
						changed = lhs.combineChanged(curAS) || changed;
						changed = lhs.mergeStacks(curAS) || changed;
					}
				}
				System.out.println("Result sigmaBar: " + lhs.getSigmaBar());
				System.out.println("Result hBar: " + lhs.getHBar());
				if (changed) {
					System.out.println("MERGED STACKS: " + lhs.getOperandStack());
					return FixedPointConstants.CHANGED;
				} else {
					return FixedPointConstants.NOT_CHANGED_AND_FIXED;
				}
			}

			@Override
			public int hashCode() {
				return myid;
			}

			@Override
			public String toString() {
				return "AbstractHeapMeetOperator";
			}
	    	
	    }