package heapabstraction;
import com.ibm.wala.cfg.ShrikeCFG;
import com.ibm.wala.dataflow.graph.AbstractMeetOperator;
import com.ibm.wala.dataflow.graph.ITransferFunctionProvider;
import com.ibm.wala.fixedpoint.impl.UnaryOperator;
import com.ibm.wala.util.debug.Assertions;


public class TransferFunctionProvider implements ITransferFunctionProvider<ShrikeCFG.BasicBlock, AbstractState> {

	   public UnaryOperator<AbstractState> getNodeTransferFunction(ShrikeCFG.BasicBlock node) {
       	return new TransferFunction(node);
       }

       public boolean hasNodeTransferFunctions() {
         return true;
       }

       public UnaryOperator<AbstractState> getEdgeTransferFunction(ShrikeCFG.BasicBlock from, ShrikeCFG.BasicBlock to) {
         Assertions.UNREACHABLE();
         return null;
       }

       public boolean hasEdgeTransferFunctions() {
         return false;
       }

       public AbstractMeetOperator<AbstractState> getMeetOperator() {
       	return new MeetOperator(); 
       }
       
}
